"use strict";
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const hljs = __importStar(require("highlight.js"));
function createHighlightPlugin(config = {}) {
    return function highlightPlugin(tree) {
        const highlightCodeTags = (node) => tree.match.call(node, { tag: 'code' }, highlightNode);
        hljs.configure(config);
        if (config.inline) {
            highlightCodeTags(tree);
        }
        else {
            tree.match({ tag: 'pre' }, highlightCodeTags);
        }
    };
}
exports.default = createHighlightPlugin;
function highlightNode(node) {
    const attrs = node.attrs || {};
    const classList = `${attrs.class || ''} hljs`.trimLeft();
    if (classList.indexOf('nohighlight') > -1)
        return node;
    const lang = getExplicitLanguage(classList);
    attrs.class = classList;
    node.attrs = attrs;
    node.content = node.content.map((c) => mapContentOrNode(c, lang));
    return node;
}
function getExplicitLanguage(classList) {
    const matches = classList.match(/(?:lang|language)-(\w*)/);
    return matches === null ? void 0 : matches[1];
}
function mapContentOrNode(contentOrNode, lang) {
    if (typeof contentOrNode === 'string') {
        if (lang) {
            return hljs.highlight(lang, contentOrNode).value;
        }
        else {
            return hljs.highlightAuto(contentOrNode).value;
        }
    }
    else {
        highlightNode(contentOrNode);
        return contentOrNode;
    }
}
